#if !defined(___Class_LIST)
    #define  ___Class_LIST

#include <iostream>
#include <string>
#include <vector>
#include <complex>
////#include <TObject.h>
#include "ReconResonance/RmatrixLimited/endf/CONT.h"
#include "ReconResonance/RmatrixLimited/endf/Numeric.h"
//using namespace std;


class LIST {

  CONT header;  vector<double> ary;

 public:

    LIST();
    LIST( const double C1, const double C2, const int L1, const int L2, const int NPL, const int N2,
          const vector<double>* b );
    LIST( const char* file_name );
    LIST( istream& is );

    virtual ~LIST();

    LIST           ( const LIST& o );
    LIST& operator=( const LIST& o );

    double  at        ( const int i ) const;
    double& at        ( const int i );
    double  operator[]( const int i ) const;
    double& operator[]( const int i );

    int  size () const;
    bool empty() const;

    LIST* resize( const int n );

    void Store( istream& is );
    void Write( ostream& os = cout, const int MAT = 0, const int MF = 0, const int MT = 0, int* NS = NULL ) const;
    void Write( const char* file_name ) const;

    LIST* Set( const LIST& o );
    LIST* Set( const double C1, const double C2, const int L1, const int L2, const int NPL, const int N2 );
    LIST* Set( const vector<double>* b );
    LIST* Set( const double C1, const double C2, const int L1, const int L2, const int NPL, const int N2,
               const vector<double>* b );
    LIST* Set( const char* file_name );

    void Print( const int n = 3 ) const;

    const double& B( const int i ) const;
          double& B( const int i );

    void Extract( const int n, const int m, vector<double>* b ) const;

    LIST* B( const vector<double>* b );

    double  C1()  const;
    double& C1();
    double  C2()  const;
    double& C2();
    int     L1()  const;
    int&    L1();
    int     L2()  const;
    int&    L2();
    int     NPL() const;
    int&    NPL();
    int     N2()  const;
    int&    N2();

    LIST* C1 ( const double val );
    LIST* C2 ( const double val );
    LIST* L1 ( const int    val );
    LIST* L2 ( const int    val );
    LIST* NPL( const int    val );
    LIST* N2 ( const int    val );

    //LIST* PushFront( const double val );
    LIST* PushBack ( const double val );
    LIST* PushBack ( const complex<double> val );

    LIST* PopFront( const int num = 1 );
    LIST* PopBack ( const int num = 1 );

    double  Front() const;
    double& Front();
    double  Back () const;
    double& Back ();

    LIST* Scale( const double fac );

    LIST* Clear();
    LIST* ClearArray();

    bool Check() const;

    bool operator==( const LIST& o ) const;
    bool operator!=( const LIST& o ) const;
    bool operator< ( const LIST& o ) const;
    bool operator> ( const LIST& o ) const;
    bool operator<=( const LIST& o ) const;
    bool operator>=( const LIST& o ) const;

    unsigned long NumberOfLines() const;

    bool Empty() const { return this->NPL() == 0 ? true : false; }

    //ClassDef( LIST, 1 );

};


istream& operator>>( istream& is,       LIST& o );
ostream& operator<<( ostream& os, const LIST& o );

#endif
