#if !defined(___Class_TEXT)
    #define  ___Class_TEXT

#include <iostream>
#include <sstream>
#include <cstring>
#include <vector>
#include "ReconResonance/RmatrixLimited/numeric/Datum.h"
#include "ReconResonance/RmatrixLimited/endf/Numeric.h"

using namespace std;
using namespace Numeric;


class TEXT {

  string text;

  public:

    TEXT();
    TEXT( istream& is );
    TEXT( const string o );

    virtual ~TEXT();

    void Store( istream& is );
    void Write( ostream& os = cout, int mat = 0, int mf = 0, int mt = 0, int* ns = NULL ) const;

    bool empty() const;
    int  size () const;

    void erase( const int pos, const int num );

    char  at        ( const int i ) const;
    char& at        ( const int i );
    char  operator[]( const int i ) const;
    char& operator[]( const int i );

    void push_front( const char o );
    void push_back ( const char o );

    void Print( ostream& os = cout ) const;

    void Set( const string o );

    bool Find( const string& o ) const;

    string Sub( const int index, const int n ) const;
    void   Sub( const char x, vector<string>* a ) const;

    TEXT* Replace( const int index, const int n, const string o );
    TEXT* Replace( const string s, const string with );

    TEXT& operator<<( const char*   o );
    TEXT& operator<<( const string& o );
    TEXT& operator<<( const int&    o );
    TEXT& operator<<( const double& o );
    TEXT& operator<<( const TEXT&   o );
    TEXT& operator<<( const Datum&  o );

    bool is_blank() const;

    //ClassDef( TEXT, 1 );

};

istream& operator>>( istream& is,       TEXT& o );
ostream& operator<<( ostream& os, const TEXT& o );

#endif
