#if !defined(___Class_Datum)
    #define  ___Class_Datum

#include <iostream>
#include <utility>
#include <cmath>
#define _USE_MATH_DEFINES
#include <math.h>
////#include <TObject.h>

using namespace std;


namespace Numeric {

  class Datum {

    pair<double,double> v;

   public:

    Datum();
    Datum( const double x, const double y = 0.0 );
   ~Datum();

    double  X() const { return v.first ; }
    double& X()       { return v.first ; }
    double  Y() const { return v.second; }
    double& Y()       { return v.second; }

    Datum* X( const double val ) { this->X() = val; return this; }
    Datum* Y( const double val ) { this->Y() = val; return this; }

    Datum* Set( const double x, const double y ) { return this->X(x)->Y(y); }

    void Write( ostream& os = cout ) const;

    bool operator==( const Datum& o ) const;
    bool operator!=( const Datum& o ) const;
    bool operator< ( const Datum& o ) const;
    bool operator> ( const Datum& o ) const;
    bool operator<=( const Datum& o ) const;
    bool operator>=( const Datum& o ) const;

    ////ClassDef( Numeric::Datum, 1 );

  };

  ostream& operator<<( ostream& os, const Datum& o );

}

#endif
